<template>
  <div class="container mt-5">
    <h2>Cadastro de Produtos</h2>
    <div class="panel-group">
      <div class="panel panel-default">
        <div class="card-header">
          <div class="form-group row">
            <div class="col-md-9">
              <input
                type="text"
                class="form-control"
                name="nserie"
                v-model="stringBusca"
                placeholder="número de série"
                required
              />
            </div>
            <div class="col-md-3">
            <a class="btn btn-warning float-right" @click="buscar(stringBusca)">
              <i class="fas fa-search"></i>buscar
            </a>
            </div>
            <div class="card-body">
              <form @submit.prevent="salvar">
                <div class="form-group row">
                  <div class="col-lg-12">
                    <input
                      type="text"
                      class="form-control"
                      name="nserie"
                      ref="nserie"
                      v-model="produto.nserie"
                      placeholder="número de série"
                      required
                    />
                  </div>
                </div>
                <div class="form-group row">
                  <div class="col-lg-6">
                    <input
                      type="text"
                      class="form-control"
                      name="marca"
                      v-model="produto.marca"
                      placeholder="marca"
                      required
                    />
                  </div>

                  <div class="col-lg-6">
                    <input
                      type="text"
                      class="form-control"
                      name="dataGarantia"
                      v-model="produto.dataGarantia"
                      placeholder="data de Garantia"
                      required
                    />
                  </div>
                </div>
                <div class="form-group row">
                  <div class="col-lg-12">
                    <input
                      type="text"
                      class="form-control"
                      name="modelo"
                      v-model="produto.modelo"
                      placeholder="modelo"
                      required
                    />
                  </div>
                </div>
                <div class="form-group row">
                  <div class="col-lg-9">
                    <input
                      type="text"
                      class="form-control"
                      name="descProduto"
                      v-model="produto.descProduto"
                      placeholder="Descrição do Produto"
                      required
                    />
                  </div>
                  <!-- <a class="btn btn-primary text-white float-right"  v-show="!tipo"  >
                      <i class="fas fa-sync"></i>Atualizar
                    </a> -->
                  <a
                    type="submit"
                    class="btn btn-success text-white float-right text-white"
                    value="Salvar"
                    @click="salvar()"
                  >
                    <i class="fas fa-plus-circle"></i>salvar
                  </a>
                </div>
              </form>
            </div>
          </div>
        </div>
      </div>
    </div>

    <table class="table table-striped mt-5">
      <thead>
        <tr>
          <th>ID</th>
          <th>N. Série</th>
          <th>marca</th>
          <th>modelo</th>
          <th>garantia</th>
        </tr>
      </thead>

      <tbody>
        <tr v-for="produto in produtos" v-bind:key="produto.id">
          <td>{{ produto.id }}</td>
          <td>{{ produto.nserie }}</td>
          <td>{{ produto.marca }}</td>
          <td>{{ produto.modelo }}</td>
          <td>{{ produto.dataGarantia }}</td>
          <td>
            <a
              data-toggle="collapse"
              href="'#' + produto.id"
              class="btn btn-sm btn-warning mx-1"
              @click="editar(produto.id)"
            >
              <i class="far fa-edit" title="Alterar"></i>
            </a>
            <a
              href="#"
              class="btn btn-sm btn-danger mx-1"
              @click="excluir(produto.id, produto.nserie)"
            >
              <i class="far fa-trash-alt" title="excluir"></i>
            </a>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
import axios from "axios";

export default {
  data() {
    return {
      stringBusca: "",
      produtos: null,
      produto: {
        id: null,
        nserie: null,
        marca: null,
        modelo: null,
        descProduto: null,
        dataGarantia: null,
      },
    };
  },
  methods: {
    listar() {
      axios
        .get(this.$MainURL + "/produtos", {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        .then((response) => (this.produtos = response.data));
    },
    buscar(nserie) {
      if (!nserie) {
        this.listar();
      } else {
        axios
          .get(this.$MainURL + "/produtos/" + nserie, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then((response) => (this.produtos = response.data));
      }
    },
    salvar() {
      if (this.produto.id) {
        axios
          .put(this.$MainURL + "/produtos/" + this.produto.id, this.produto, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          // eslint-disable-next-line no-unused-vars
          .then((response) => {
            alert(`Ok, Alterado com sucesso`);
            this.listar();
            this.produto = {};
          });
      } else {
        axios
          .post(this.$MainURL + "/produtos", this.produto, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then((response) => {
            alert(`Ok, cadastrado com ID: ${response.data.id}`);
            this.listar();
            this.produto = {};
          });
      }
    },
    editar(id) {
      axios
        .get(this.$MainURL + "/produto/" + id, {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        .then((response) => (this.produto = response.data));
      this.$refs.nserie.focus();
    },
    excluir(id, cod) {
      if (confirm(`Confirma exclusão do filme '${cod}`));

      axios
        .delete(this.$MainURL + "/produtos/" + id, {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        // eslint-disable-next-line no-unused-vars
        .then((response) => {
          alert(`produto '${cod}' excluido com sucesso`);
          this.listar();
        });
    },
    sal(id) {
      setTimeout(() => {
        this.produto.id = id;
        this.axios
          .post(this.$MainURL + "/produtos", this.produtos, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then(this.GoBack());
      }, 3000);
    },
    GoBack() {
      window.history.length > 1 ? this.$router.go(-1) : this.$router.push("/");
    },
  },
  mounted() {
    this.listar();
  },
};
</script>

<style scoped></style>
